#
# spec file for package ghc-cabal-helper
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name cabal-helper
%bcond_with tests
Name:           ghc-cabal-helper
Version:        0.6.3.1
Release:        2.9
Summary:        Simple interface to some of Cabal's configuration state used by ghc-mod
License:        AGPL-3.0+
Group:          System/Libraries
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
# Begin cabal-rpm deps:
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-data-default-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-temporary-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-utf8-string-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if %{with tests}
BuildRequires:  ghc-extra-devel
BuildRequires:  ghc-unix-devel
%endif
# End cabal-rpm deps

%description
'cabal-helper' provides a library which wraps the internal use of anexecutable
to lift the restrictions imposed by linking against versions of GHC before
'7.10'. This has the pleasant side effect of isolating the user from having to
deal with Cabal version changes manually as 'cabal-helper' can simply recompile
it's helper program automatically as needed.

'cabal-helper' uses a wrapper executable to compile the actual cabal-helper
executable at runtime while linking against an arbitrary version of Cabal.
This runtime-compiled helper executable is then used to extract various bits
and peices from Cabal's on disk state (dist/setup-config) written by it's
configure command.

In addition to this the wrapper executable also supports installing any version
of Cabal from hackage in case it cannot be found in any available package
database. The wrapper installs these instances of the Cabal library into a
private package database so as to not interfere with the user's packages.

Furthermore the wrapper supports one special case namely reading a state file
for Cabal itself. This is needed as Cabal compiles it's Setup.hs using itself
and not using any version of Cabal installed in any package database.

'cabal-helper' can compile with 'Cabal >= 1.14' but requires 'Cabal >= 1.16' at
runtime.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%define cabal_configure_options --libexecdir=%{_libexecdir}
%ghc_lib_build

%install
%ghc_lib_install

%check
%if %{with tests}
%cabal test
%endif

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE
%{_libexecdir}/cabal-helper-wrapper

%files devel -f %{name}-devel.files
%defattr(-,root,root,-)

%changelog
* Fri Jan 22 2016 mimi.vx@gmail.com
- update to 0.6.3.1
* Mon Jan 11 2016 mimi.vx@gmail.com
- update to 0.6.3.0
* Wed Dec 23 2015 mimi.vx@gmail.com
- update to 0.6.2.0
* Mon Nov  2 2015 mimi.vx@gmail.com
- update to 0.6.1.0
* Mon Sep 28 2015 mimi.vx@gmail.com
- update to 0.6.0.0
* Sun Aug 30 2015 mimi.vx@gmail.com
- rework %%install
* Fri Aug 28 2015 mimi.vx@gmail.com
- move cabal-helper-wrapper to %%_libexecdir
* Wed Aug 26 2015 mimi.vx@gmail.com
- update to 0.5.2.0
* Thu Aug 13 2015 mimi.vx@gmail.com
- initial commit
